<?php

$input_file = "dllfunctions.txt"; // GEX import file
$dllname = "HttpDll";
$dllfile = "http_dll_2_3.dll";

$type_real = "double";
$type_string = "const char*";

$output_newline = "\r\n";

$data = file_get_contents($input_file);
if($data === FALSE)
	die("Can't load input file.\n");
$lines = explode("\n", str_replace("\r", "", $data));

$ptrlist = "";
$externptrlist = "";
$loadptrlist = "";

foreach($lines as $l => $line) {
	$words = explode(" ", $line);
	if(count($words) != 2) continue;
	if($words[0] == "function") {
		if(preg_match("/^(.+)\((.*)\):(.+)$/U", $words[1], $match)) {

			$function_name = $match[1];
			$function_arguments = "";
			$function_argumenttypes = "";
			$function_restype = ($match[3] == "real")? $type_real : $type_string;

			if($match[2] != "") {
				$a = explode(";", $match[2]);
				foreach($a as $i => $b) {
					$c = explode(":", $b);
					if(count($c) != 2)
						die("Error in argument " . ($i + 1) . " on line " . ($l + 1) . "\n");
					if($function_arguments != "") $function_arguments .= ", ";
					$function_arguments .= (($c[1] == "real")? $type_real : $type_string) . " " . $c[0];
				}
			}
			
			$funcptr = $function_restype . " (*" . $function_name . ")(" . $function_arguments . ");";
			$ptrlist .= $funcptr . "\n";
			$externptrlist .= "extern " . $funcptr . "\n";
			$loadptrlist .= "\tload_from_" . $dllname . "(" . $function_name . ", \"" . $function_name . "\");" . "\n";

		}
	}
}

$template_header = str_replace("\r", "", file_get_contents("template.h"));
if($data === FALSE)
	die("Can't load template header file.\n");
$template_source = str_replace("\r", "", file_get_contents("template.cpp"));
if($data === FALSE)
	die("Can't load template source file.\n");
	
$tr = array(
	"%DLLNAME%" => $dllname,
	"%DLLFILE%" => $dllfile,
	"%PTRLIST%" => $ptrlist,
	"%EXTERNPTRLIST%" => $externptrlist,
	"%LOADPTRLIST%" => $loadptrlist,
);
file_put_contents("load_" . $dllname . ".h", str_replace("\n", $output_newline, strtr($template_header, $tr)));
file_put_contents("load_" . $dllname . ".cpp", str_replace("\n", $output_newline, strtr($template_source, $tr)));

?>
