#include "load_HttpDll.h"
#include <windows.h>

HINSTANCE handle_HttpDll;

template<typename FP>
void load_from_HttpDll(FP& fp, const char* name) {
	fp = (FP)(GetProcAddress(handle_HttpDll, name));
	if(fp == NULL) {
		throw "Loading DLL function failed!";
	}
}

void load_HttpDll() {
	
	handle_HttpDll = LoadLibrary("http_dll_2_3.dll");
	if(handle_HttpDll == NULL) {
		throw "Loading DLL failed!";
	}
	
	load_from_HttpDll(buffer_create, "buffer_create");
	load_from_HttpDll(buffer_destroy, "buffer_destroy");
	load_from_HttpDll(buffer_exists, "buffer_exists");
	load_from_HttpDll(buffer_to_string, "buffer_to_string");
	load_from_HttpDll(buffer_get_pos, "buffer_get_pos");
	load_from_HttpDll(buffer_get_length, "buffer_get_length");
	load_from_HttpDll(buffer_at_end, "buffer_at_end");
	load_from_HttpDll(buffer_get_error, "buffer_get_error");
	load_from_HttpDll(buffer_clear_error, "buffer_clear_error");
	load_from_HttpDll(buffer_clear, "buffer_clear");
	load_from_HttpDll(buffer_set_pos, "buffer_set_pos");
	load_from_HttpDll(buffer_read_from_file, "buffer_read_from_file");
	load_from_HttpDll(buffer_read_from_file_part, "buffer_read_from_file_part");
	load_from_HttpDll(buffer_write_to_file, "buffer_write_to_file");
	load_from_HttpDll(buffer_append_to_file, "buffer_append_to_file");
	load_from_HttpDll(buffer_rc4_crypt, "buffer_rc4_crypt");
	load_from_HttpDll(buffer_rc4_crypt_buffer, "buffer_rc4_crypt_buffer");
	load_from_HttpDll(buffer_zlib_compress, "buffer_zlib_compress");
	load_from_HttpDll(buffer_zlib_uncompress, "buffer_zlib_uncompress");
	load_from_HttpDll(buffer_read_int8, "buffer_read_int8");
	load_from_HttpDll(buffer_read_uint8, "buffer_read_uint8");
	load_from_HttpDll(buffer_read_int16, "buffer_read_int16");
	load_from_HttpDll(buffer_read_uint16, "buffer_read_uint16");
	load_from_HttpDll(buffer_read_int32, "buffer_read_int32");
	load_from_HttpDll(buffer_read_uint32, "buffer_read_uint32");
	load_from_HttpDll(buffer_read_int64, "buffer_read_int64");
	load_from_HttpDll(buffer_read_uint64, "buffer_read_uint64");
	load_from_HttpDll(buffer_read_intv, "buffer_read_intv");
	load_from_HttpDll(buffer_read_uintv, "buffer_read_uintv");
	load_from_HttpDll(buffer_read_float32, "buffer_read_float32");
	load_from_HttpDll(buffer_read_float64, "buffer_read_float64");
	load_from_HttpDll(buffer_write_int8, "buffer_write_int8");
	load_from_HttpDll(buffer_write_uint8, "buffer_write_uint8");
	load_from_HttpDll(buffer_write_int16, "buffer_write_int16");
	load_from_HttpDll(buffer_write_uint16, "buffer_write_uint16");
	load_from_HttpDll(buffer_write_int32, "buffer_write_int32");
	load_from_HttpDll(buffer_write_uint32, "buffer_write_uint32");
	load_from_HttpDll(buffer_write_int64, "buffer_write_int64");
	load_from_HttpDll(buffer_write_uint64, "buffer_write_uint64");
	load_from_HttpDll(buffer_write_intv, "buffer_write_intv");
	load_from_HttpDll(buffer_write_uintv, "buffer_write_uintv");
	load_from_HttpDll(buffer_write_float32, "buffer_write_float32");
	load_from_HttpDll(buffer_write_float64, "buffer_write_float64");
	load_from_HttpDll(buffer_read_string, "buffer_read_string");
	load_from_HttpDll(buffer_write_string, "buffer_write_string");
	load_from_HttpDll(buffer_read_data, "buffer_read_data");
	load_from_HttpDll(buffer_write_data, "buffer_write_data");
	load_from_HttpDll(buffer_read_hex, "buffer_read_hex");
	load_from_HttpDll(buffer_write_hex, "buffer_write_hex");
	load_from_HttpDll(buffer_read_base64, "buffer_read_base64");
	load_from_HttpDll(buffer_write_base64, "buffer_write_base64");
	load_from_HttpDll(buffer_write_buffer, "buffer_write_buffer");
	load_from_HttpDll(buffer_write_buffer_part, "buffer_write_buffer_part");
	load_from_HttpDll(md5_begin, "md5_begin");
	load_from_HttpDll(md5_end, "md5_end");
	load_from_HttpDll(md5_read_file, "md5_read_file");
	load_from_HttpDll(md5_read_string, "md5_read_string");
	load_from_HttpDll(md5_read_buffer, "md5_read_buffer");
	load_from_HttpDll(md5_read_buffer_part, "md5_read_buffer_part");
	load_from_HttpDll(md5_result, "md5_result");
	load_from_HttpDll(sha1_begin, "sha1_begin");
	load_from_HttpDll(sha1_end, "sha1_end");
	load_from_HttpDll(sha1_read_file, "sha1_read_file");
	load_from_HttpDll(sha1_read_string, "sha1_read_string");
	load_from_HttpDll(sha1_read_buffer, "sha1_read_buffer");
	load_from_HttpDll(sha1_read_buffer_part, "sha1_read_buffer_part");
	load_from_HttpDll(sha1_result, "sha1_result");
	load_from_HttpDll(listeningsocket_create, "listeningsocket_create");
	load_from_HttpDll(listeningsocket_destroy, "listeningsocket_destroy");
	load_from_HttpDll(listeningsocket_exists, "listeningsocket_exists");
	load_from_HttpDll(listeningsocket_is_listening, "listeningsocket_is_listening");
	load_from_HttpDll(listeningsocket_start_listening, "listeningsocket_start_listening");
	load_from_HttpDll(listeningsocket_stop_listening, "listeningsocket_stop_listening");
	load_from_HttpDll(listeningsocket_can_accept, "listeningsocket_can_accept");
	load_from_HttpDll(listeningsocket_accept, "listeningsocket_accept");
	load_from_HttpDll(socket_create, "socket_create");
	load_from_HttpDll(socket_destroy, "socket_destroy");
	load_from_HttpDll(socket_exists, "socket_exists");
	load_from_HttpDll(socket_get_state, "socket_get_state");
	load_from_HttpDll(socket_reset, "socket_reset");
	load_from_HttpDll(socket_connect, "socket_connect");
	load_from_HttpDll(socket_update_read, "socket_update_read");
	load_from_HttpDll(socket_update_write, "socket_update_write");
	load_from_HttpDll(socket_shut_down, "socket_shut_down");
	load_from_HttpDll(socket_get_peer_address, "socket_get_peer_address");
	load_from_HttpDll(socket_read_data, "socket_read_data");
	load_from_HttpDll(socket_write_data, "socket_write_data");
	load_from_HttpDll(socket_read_message, "socket_read_message");
	load_from_HttpDll(socket_write_message, "socket_write_message");
	load_from_HttpDll(socket_read_message_delimiter, "socket_read_message_delimiter");
	load_from_HttpDll(socket_write_message_delimiter, "socket_write_message_delimiter");
	load_from_HttpDll(socket_get_read_data_length, "socket_get_read_data_length");
	load_from_HttpDll(socket_get_write_data_length, "socket_get_write_data_length");
	load_from_HttpDll(udpsocket_create, "udpsocket_create");
	load_from_HttpDll(udpsocket_destroy, "udpsocket_destroy");
	load_from_HttpDll(udpsocket_exists, "udpsocket_exists");
	load_from_HttpDll(udpsocket_get_state, "udpsocket_get_state");
	load_from_HttpDll(udpsocket_reset, "udpsocket_reset");
	load_from_HttpDll(udpsocket_start, "udpsocket_start");
	load_from_HttpDll(udpsocket_set_destination, "udpsocket_set_destination");
	load_from_HttpDll(udpsocket_receive, "udpsocket_receive");
	load_from_HttpDll(udpsocket_send, "udpsocket_send");
	load_from_HttpDll(udpsocket_get_last_address, "udpsocket_get_last_address");
	load_from_HttpDll(udpsocket_get_last_port, "udpsocket_get_last_port");
	load_from_HttpDll(udpsocket_get_max_message_size, "udpsocket_get_max_message_size");
	load_from_HttpDll(httprequest_create, "httprequest_create");
	load_from_HttpDll(httprequest_destroy, "httprequest_destroy");
	load_from_HttpDll(httprequest_exists, "httprequest_exists");
	load_from_HttpDll(httprequest_get_state, "httprequest_get_state");
	load_from_HttpDll(httprequest_set_request_header, "httprequest_set_request_header");
	load_from_HttpDll(httprequest_remove_request_header, "httprequest_remove_request_header");
	load_from_HttpDll(httprequest_clear_request_headers, "httprequest_clear_request_headers");
	load_from_HttpDll(httprequest_set_post_parameter, "httprequest_set_post_parameter");
	load_from_HttpDll(httprequest_set_post_parameter_file, "httprequest_set_post_parameter_file");
	load_from_HttpDll(httprequest_remove_post_parameter, "httprequest_remove_post_parameter");
	load_from_HttpDll(httprequest_clear_post_parameters, "httprequest_clear_post_parameters");
	load_from_HttpDll(httprequest_reset, "httprequest_reset");
	load_from_HttpDll(httprequest_connect, "httprequest_connect");
	load_from_HttpDll(httprequest_update, "httprequest_update");
	load_from_HttpDll(httprequest_get_status_code, "httprequest_get_status_code");
	load_from_HttpDll(httprequest_get_response_header_count, "httprequest_get_response_header_count");
	load_from_HttpDll(httprequest_get_response_header_name, "httprequest_get_response_header_name");
	load_from_HttpDll(httprequest_get_response_header_value, "httprequest_get_response_header_value");
	load_from_HttpDll(httprequest_find_response_header, "httprequest_find_response_header");
	load_from_HttpDll(httprequest_get_message_body, "httprequest_get_message_body");
	load_from_HttpDll(httprequest_get_message_body_length, "httprequest_get_message_body_length");
	load_from_HttpDll(httprequest_get_message_body_buffer, "httprequest_get_message_body_buffer");
	load_from_HttpDll(httprequest_urlencode, "httprequest_urlencode");

	
}

double (*buffer_create)();
double (*buffer_destroy)(double id);
double (*buffer_exists)(double id);
const char* (*buffer_to_string)(double id);
double (*buffer_get_pos)(double id);
double (*buffer_get_length)(double id);
double (*buffer_at_end)(double id);
double (*buffer_get_error)(double id);
double (*buffer_clear_error)(double id);
double (*buffer_clear)(double id);
double (*buffer_set_pos)(double id, double pos);
double (*buffer_read_from_file)(double id, const char* filename);
double (*buffer_read_from_file_part)(double id, const char* filename, double pos, double len);
double (*buffer_write_to_file)(double id, const char* filename);
double (*buffer_append_to_file)(double id, const char* filename);
double (*buffer_rc4_crypt)(double id, const char* key);
double (*buffer_rc4_crypt_buffer)(double id, double id2);
double (*buffer_zlib_compress)(double id);
double (*buffer_zlib_uncompress)(double id);
double (*buffer_read_int8)(double id);
double (*buffer_read_uint8)(double id);
double (*buffer_read_int16)(double id);
double (*buffer_read_uint16)(double id);
double (*buffer_read_int32)(double id);
double (*buffer_read_uint32)(double id);
double (*buffer_read_int64)(double id);
double (*buffer_read_uint64)(double id);
double (*buffer_read_intv)(double id);
double (*buffer_read_uintv)(double id);
double (*buffer_read_float32)(double id);
double (*buffer_read_float64)(double id);
double (*buffer_write_int8)(double id, double value);
double (*buffer_write_uint8)(double id, double value);
double (*buffer_write_int16)(double id, double value);
double (*buffer_write_uint16)(double id, double value);
double (*buffer_write_int32)(double id, double value);
double (*buffer_write_uint32)(double id, double value);
double (*buffer_write_int64)(double id, double value);
double (*buffer_write_uint64)(double id, double value);
double (*buffer_write_intv)(double id, double value);
double (*buffer_write_uintv)(double id, double value);
double (*buffer_write_float32)(double id, double value);
double (*buffer_write_float64)(double id, double value);
const char* (*buffer_read_string)(double id);
double (*buffer_write_string)(double id, const char* string);
const char* (*buffer_read_data)(double id, double len);
double (*buffer_write_data)(double id, const char* string);
const char* (*buffer_read_hex)(double id, double len);
double (*buffer_write_hex)(double id, const char* string);
const char* (*buffer_read_base64)(double id, double len);
double (*buffer_write_base64)(double id, const char* string);
double (*buffer_write_buffer)(double id, double id2);
double (*buffer_write_buffer_part)(double id, double id2, double pos, double len);
double (*md5_begin)();
double (*md5_end)();
double (*md5_read_file)(const char* filename);
double (*md5_read_string)(const char* string);
double (*md5_read_buffer)(double id);
double (*md5_read_buffer_part)(double id, double pos, double len);
const char* (*md5_result)();
double (*sha1_begin)();
double (*sha1_end)();
double (*sha1_read_file)(const char* filename);
double (*sha1_read_string)(const char* string);
double (*sha1_read_buffer)(double id);
double (*sha1_read_buffer_part)(double id, double pos, double len);
const char* (*sha1_result)();
double (*listeningsocket_create)();
double (*listeningsocket_destroy)(double id);
double (*listeningsocket_exists)(double id);
double (*listeningsocket_is_listening)(double id);
double (*listeningsocket_start_listening)(double id, double ipv6, double port, double local);
double (*listeningsocket_stop_listening)(double id);
double (*listeningsocket_can_accept)(double id);
double (*listeningsocket_accept)(double id, double socket_id);
double (*socket_create)();
double (*socket_destroy)(double id);
double (*socket_exists)(double id);
double (*socket_get_state)(double id);
double (*socket_reset)(double id);
double (*socket_connect)(double id, const char* address, double port);
double (*socket_update_read)(double id);
double (*socket_update_write)(double id);
double (*socket_shut_down)(double id);
const char* (*socket_get_peer_address)(double id);
double (*socket_read_data)(double id, double buffer_id, double bytes);
double (*socket_write_data)(double id, double buffer_id);
double (*socket_read_message)(double id, double buffer_id);
double (*socket_write_message)(double id, double buffer_id);
double (*socket_read_message_delimiter)(double id, double buffer_id, const char* delimiter);
double (*socket_write_message_delimiter)(double id, double buffer_id, const char* delimiter);
double (*socket_get_read_data_length)(double id);
double (*socket_get_write_data_length)(double id);
double (*udpsocket_create)();
double (*udpsocket_destroy)(double id);
double (*udpsocket_exists)(double id);
double (*udpsocket_get_state)(double id);
double (*udpsocket_reset)(double id);
double (*udpsocket_start)(double id, double ipv6, double port);
double (*udpsocket_set_destination)(double id, const char* address, double port);
double (*udpsocket_receive)(double id, double buffer_id);
double (*udpsocket_send)(double id, double buffer_id);
const char* (*udpsocket_get_last_address)(double id);
double (*udpsocket_get_last_port)(double id);
double (*udpsocket_get_max_message_size)(double id);
double (*httprequest_create)();
double (*httprequest_destroy)(double id);
double (*httprequest_exists)(double id);
double (*httprequest_get_state)(double id);
double (*httprequest_set_request_header)(double id, const char* name, const char* value, double replace);
double (*httprequest_remove_request_header)(double id, const char* name);
double (*httprequest_clear_request_headers)(double id);
double (*httprequest_set_post_parameter)(double id, const char* name, const char* value);
double (*httprequest_set_post_parameter_file)(double id, const char* name, const char* filename, double buffer_id);
double (*httprequest_remove_post_parameter)(double id, const char* name);
double (*httprequest_clear_post_parameters)(double id);
double (*httprequest_reset)(double id);
double (*httprequest_connect)(double id, const char* url, double post);
double (*httprequest_update)(double id);
double (*httprequest_get_status_code)(double id);
double (*httprequest_get_response_header_count)(double id);
const char* (*httprequest_get_response_header_name)(double id, double index);
const char* (*httprequest_get_response_header_value)(double id, double index);
const char* (*httprequest_find_response_header)(double id, const char* name);
const char* (*httprequest_get_message_body)(double id);
double (*httprequest_get_message_body_length)(double id);
double (*httprequest_get_message_body_buffer)(double id, double buffer_id);
const char* (*httprequest_urlencode)(const char* string, double keepspecialchars);


