#pragma once

void load_HttpDll();

extern double (*buffer_create)();
extern double (*buffer_destroy)(double id);
extern double (*buffer_exists)(double id);
extern const char* (*buffer_to_string)(double id);
extern double (*buffer_get_pos)(double id);
extern double (*buffer_get_length)(double id);
extern double (*buffer_at_end)(double id);
extern double (*buffer_get_error)(double id);
extern double (*buffer_clear_error)(double id);
extern double (*buffer_clear)(double id);
extern double (*buffer_set_pos)(double id, double pos);
extern double (*buffer_read_from_file)(double id, const char* filename);
extern double (*buffer_read_from_file_part)(double id, const char* filename, double pos, double len);
extern double (*buffer_write_to_file)(double id, const char* filename);
extern double (*buffer_append_to_file)(double id, const char* filename);
extern double (*buffer_rc4_crypt)(double id, const char* key);
extern double (*buffer_rc4_crypt_buffer)(double id, double id2);
extern double (*buffer_zlib_compress)(double id);
extern double (*buffer_zlib_uncompress)(double id);
extern double (*buffer_read_int8)(double id);
extern double (*buffer_read_uint8)(double id);
extern double (*buffer_read_int16)(double id);
extern double (*buffer_read_uint16)(double id);
extern double (*buffer_read_int32)(double id);
extern double (*buffer_read_uint32)(double id);
extern double (*buffer_read_int64)(double id);
extern double (*buffer_read_uint64)(double id);
extern double (*buffer_read_intv)(double id);
extern double (*buffer_read_uintv)(double id);
extern double (*buffer_read_float32)(double id);
extern double (*buffer_read_float64)(double id);
extern double (*buffer_write_int8)(double id, double value);
extern double (*buffer_write_uint8)(double id, double value);
extern double (*buffer_write_int16)(double id, double value);
extern double (*buffer_write_uint16)(double id, double value);
extern double (*buffer_write_int32)(double id, double value);
extern double (*buffer_write_uint32)(double id, double value);
extern double (*buffer_write_int64)(double id, double value);
extern double (*buffer_write_uint64)(double id, double value);
extern double (*buffer_write_intv)(double id, double value);
extern double (*buffer_write_uintv)(double id, double value);
extern double (*buffer_write_float32)(double id, double value);
extern double (*buffer_write_float64)(double id, double value);
extern const char* (*buffer_read_string)(double id);
extern double (*buffer_write_string)(double id, const char* string);
extern const char* (*buffer_read_data)(double id, double len);
extern double (*buffer_write_data)(double id, const char* string);
extern const char* (*buffer_read_hex)(double id, double len);
extern double (*buffer_write_hex)(double id, const char* string);
extern const char* (*buffer_read_base64)(double id, double len);
extern double (*buffer_write_base64)(double id, const char* string);
extern double (*buffer_write_buffer)(double id, double id2);
extern double (*buffer_write_buffer_part)(double id, double id2, double pos, double len);
extern double (*md5_begin)();
extern double (*md5_end)();
extern double (*md5_read_file)(const char* filename);
extern double (*md5_read_string)(const char* string);
extern double (*md5_read_buffer)(double id);
extern double (*md5_read_buffer_part)(double id, double pos, double len);
extern const char* (*md5_result)();
extern double (*sha1_begin)();
extern double (*sha1_end)();
extern double (*sha1_read_file)(const char* filename);
extern double (*sha1_read_string)(const char* string);
extern double (*sha1_read_buffer)(double id);
extern double (*sha1_read_buffer_part)(double id, double pos, double len);
extern const char* (*sha1_result)();
extern double (*listeningsocket_create)();
extern double (*listeningsocket_destroy)(double id);
extern double (*listeningsocket_exists)(double id);
extern double (*listeningsocket_is_listening)(double id);
extern double (*listeningsocket_start_listening)(double id, double ipv6, double port, double local);
extern double (*listeningsocket_stop_listening)(double id);
extern double (*listeningsocket_can_accept)(double id);
extern double (*listeningsocket_accept)(double id, double socket_id);
extern double (*socket_create)();
extern double (*socket_destroy)(double id);
extern double (*socket_exists)(double id);
extern double (*socket_get_state)(double id);
extern double (*socket_reset)(double id);
extern double (*socket_connect)(double id, const char* address, double port);
extern double (*socket_update_read)(double id);
extern double (*socket_update_write)(double id);
extern double (*socket_shut_down)(double id);
extern const char* (*socket_get_peer_address)(double id);
extern double (*socket_read_data)(double id, double buffer_id, double bytes);
extern double (*socket_write_data)(double id, double buffer_id);
extern double (*socket_read_message)(double id, double buffer_id);
extern double (*socket_write_message)(double id, double buffer_id);
extern double (*socket_read_message_delimiter)(double id, double buffer_id, const char* delimiter);
extern double (*socket_write_message_delimiter)(double id, double buffer_id, const char* delimiter);
extern double (*socket_get_read_data_length)(double id);
extern double (*socket_get_write_data_length)(double id);
extern double (*udpsocket_create)();
extern double (*udpsocket_destroy)(double id);
extern double (*udpsocket_exists)(double id);
extern double (*udpsocket_get_state)(double id);
extern double (*udpsocket_reset)(double id);
extern double (*udpsocket_start)(double id, double ipv6, double port);
extern double (*udpsocket_set_destination)(double id, const char* address, double port);
extern double (*udpsocket_receive)(double id, double buffer_id);
extern double (*udpsocket_send)(double id, double buffer_id);
extern const char* (*udpsocket_get_last_address)(double id);
extern double (*udpsocket_get_last_port)(double id);
extern double (*udpsocket_get_max_message_size)(double id);
extern double (*httprequest_create)();
extern double (*httprequest_destroy)(double id);
extern double (*httprequest_exists)(double id);
extern double (*httprequest_get_state)(double id);
extern double (*httprequest_set_request_header)(double id, const char* name, const char* value, double replace);
extern double (*httprequest_remove_request_header)(double id, const char* name);
extern double (*httprequest_clear_request_headers)(double id);
extern double (*httprequest_set_post_parameter)(double id, const char* name, const char* value);
extern double (*httprequest_set_post_parameter_file)(double id, const char* name, const char* filename, double buffer_id);
extern double (*httprequest_remove_post_parameter)(double id, const char* name);
extern double (*httprequest_clear_post_parameters)(double id);
extern double (*httprequest_reset)(double id);
extern double (*httprequest_connect)(double id, const char* url, double post);
extern double (*httprequest_update)(double id);
extern double (*httprequest_get_status_code)(double id);
extern double (*httprequest_get_response_header_count)(double id);
extern const char* (*httprequest_get_response_header_name)(double id, double index);
extern const char* (*httprequest_get_response_header_value)(double id, double index);
extern const char* (*httprequest_find_response_header)(double id, const char* name);
extern const char* (*httprequest_get_message_body)(double id);
extern double (*httprequest_get_message_body_length)(double id);
extern double (*httprequest_get_message_body_buffer)(double id, double buffer_id);
extern const char* (*httprequest_urlencode)(const char* string, double keepspecialchars);


